searchNodes=[{"doc":"SemanticMarkdown is a module for parsing Markdown syntax (using Earmark ) while retaining semantic structure of the document defined by XML-tags. E.g.: iex&gt; SemanticMarkdown . transform ( ~S&quot;&quot;&quot; ...&gt; &lt;title&gt;Lorem ipsum&lt;/title&gt; ...&gt; Hello world! ...&gt; &quot;&quot;&quot; , [ :title ] ) [ title : &quot;&lt;p&gt;Lorem ipsum&lt;/p&gt;&quot; , content : &quot;&lt;p&gt;Hello world!&lt;/p&gt;&quot; ] SemanticMarkdown.transform takes 3 parameters: markdown_string - input markdown (including optionally XML demarking semantic parts) semantic_tags - list of atoms of tags to parse options - Keyword list such as SemanticMarkdown.Type.options/0 It is possible to disable parsing inner tags: iex&gt; options = [ earmark_inner_transform : false ] iex&gt; SemanticMarkdown . transform ( ~S&quot;&quot;&quot; ...&gt; &lt;title&gt;Lorem ipsum&lt;/title&gt; ...&gt; Hello world! ...&gt; &quot;&quot;&quot; , [ :title ] , options ) [ title : &quot;Lorem ipsum&quot; , content : &quot;&lt;p&gt;Hello world!&lt;/p&gt;&quot; ] As the parsing result is a list same named tags can occur multiple times: iex&gt; options = [ earmark_inner_transform : false ] iex&gt; markdown = &quot;&quot;&quot; ...&gt; &lt;color_marker&gt;red&lt;/color_marker&gt; ...&gt; &lt;color_marker&gt;blue&lt;/color_marker&gt; ...&gt; &lt;color_marker&gt;green&lt;/color_marker&gt; ...&gt; &lt;title&gt;Coloring book&lt;/title&gt; ...&gt; Hello world! ...&gt; &quot;&quot;&quot; iex&gt; SemanticMarkdown . transform ( markdown , [ :color_marker , :title ] , options ) [ color_marker : &quot;red&quot; , color_marker : &quot;blue&quot; , color_marker : &quot;green&quot; , title : &quot;Coloring book&quot; , content : &quot;&lt;p&gt;Hello world!&lt;/p&gt;&quot; ] Content is optional: iex&gt; options = [ earmark_inner_transform : false ] iex&gt; markdown = &quot;&quot;&quot; ...&gt; &lt;color_marker&gt;red&lt;/color_marker&gt; ...&gt; &lt;color_marker&gt;blue&lt;/color_marker&gt; ...&gt; &lt;color_marker&gt;green&lt;/color_marker&gt; ...&gt; &quot;&quot;&quot; iex&gt; SemanticMarkdown . transform ( markdown , [ :color_marker , :title ] , options ) [ color_marker : &quot;red&quot; , color_marker : &quot;blue&quot; , color_marker : &quot;green&quot; ] It's possible to have self-closing tags, however attribute information is missing: iex&gt; options = [ earmark_inner_transform : false ] iex&gt; markdown = &quot;&quot;&quot; ...&gt; # Title ...&gt; Hello! ...&gt; &lt;boing/&gt; ...&gt; &lt;boing/&gt; ...&gt; &lt;boing/&gt; ...&gt; Bye! ...&gt; &quot;&quot;&quot; iex&gt; SemanticMarkdown . transform ( markdown , [ :boing ] , options ) [ content : &quot;&lt;h1&gt;Title&lt;/h1&gt;&lt;p&gt;Hello!&lt;/p&gt;&quot; , boing : true , boing : true , boing : true , content : &quot;&lt;p&gt;Bye!&lt;/p&gt;&quot; ]","ref":"SemanticMarkdown.html","title":"SemanticMarkdown","type":"module"},{"doc":"Transforms markdown_string into keyworded list containing separated parts by semantic tag","ref":"SemanticMarkdown.html#transform/3","title":"SemanticMarkdown.transform/3","type":"function"},{"doc":"Helper function that takes a file path string, list of tags and options and returns keyword list of parsed content.","ref":"SemanticMarkdown.html#transform_from_file!/3","title":"SemanticMarkdown.transform_from_file!/3","type":"function"},{"doc":"SemanticMarkdown.AST module contains utilities for transforming Earmark 's AST.","ref":"SemanticMarkdown.AST.html","title":"SemanticMarkdown.AST","type":"module"},{"doc":"","ref":"SemanticMarkdown.AST.html#is_temporary_tag/1","title":"SemanticMarkdown.AST.is_temporary_tag/1","type":"macro"},{"doc":"Transform AST tree so that non-tagged nodes get a node by themselves (and sibling nodes are combined into one)","ref":"SemanticMarkdown.AST.html#preparse/2","title":"SemanticMarkdown.AST.preparse/2","type":"function"},{"doc":"Helper function, replace the value of given attribute with the other one","ref":"SemanticMarkdown.AST.html#replace_attr/3","title":"SemanticMarkdown.AST.replace_attr/3","type":"function"},{"doc":"Replace Earmark 's footnotes with the ones provided in configuration","ref":"SemanticMarkdown.AST.html#translate_footnotes/2","title":"SemanticMarkdown.AST.translate_footnotes/2","type":"function"},{"doc":"SemanticMarkdown.Inner Contains inner implementation of Markdown parser, including transform that allows to work on the Earmark 's AST tree directly and transform_text that takes processed SemanticMarkdown.Type.options_map() .","ref":"SemanticMarkdown.Inner.html","title":"SemanticMarkdown.Inner","type":"module"},{"doc":"Parse semantically tagged markdown string into the keyword list. This function requires options to be provided in t:Type.options_map() format.","ref":"SemanticMarkdown.Inner.html#transform_text/2","title":"SemanticMarkdown.Inner.transform_text/2","type":"function"},{"doc":"","ref":"SemanticMarkdown.Inner.html#transform_text_inner/2","title":"SemanticMarkdown.Inner.transform_text_inner/2","type":"function"},{"doc":"SemanticMarkdown.Type is a module containing used types within SemanticMarkdown","ref":"SemanticMarkdown.Type.html","title":"SemanticMarkdown.Type","type":"module"},{"doc":"","ref":"SemanticMarkdown.Type.html#t:ast/0","title":"SemanticMarkdown.Type.ast/0","type":"type"},{"doc":"","ref":"SemanticMarkdown.Type.html#t:ast_tuple/0","title":"SemanticMarkdown.Type.ast_tuple/0","type":"type"},{"doc":"","ref":"SemanticMarkdown.Type.html#t:content/0","title":"SemanticMarkdown.Type.content/0","type":"type"},{"doc":"","ref":"SemanticMarkdown.Type.html#t:content_map/0","title":"SemanticMarkdown.Type.content_map/0","type":"type"},{"doc":"","ref":"SemanticMarkdown.Type.html#t:option/0","title":"SemanticMarkdown.Type.option/0","type":"type"},{"doc":"Keyword list of options. Available options: Own footnotes_see - Title of footnote link (default: &quot;see footnote&quot; ), see Foonotes Rationale footnotes_return - Same as above but for the return link (default: &quot;return to article&quot; ) clean_newlines - By default Markdown outputs nice parse such as: &lt;p&gt;\\ncontent\\n&lt;/p&gt; . This setting cleans it out (default: true ) earmark_inner_transform - whether parsed inner tags should be re-parsed once more as Markdown (default: true ) content_tag_name - name of the default content, i.e. not marked by any semantic tags (default: &quot;content&quot; ) merge_content - whether to merge non-tagged nodes and put it as a final &quot;content&quot; node (default: false ) Earmark 's footnotes - whether Earmark should parse footnotes (default: true ) earmark_transform_options - options passed directly to Earmark.transform (default: %{} )","ref":"SemanticMarkdown.Type.html#t:options/0","title":"SemanticMarkdown.Type.options/0","type":"type"},{"doc":"","ref":"SemanticMarkdown.Type.html#t:options_map/0","title":"SemanticMarkdown.Type.options_map/0","type":"type"},{"doc":"Keyword list containing Markdown transformed into HTML. Minimal result is [content: String.t] representing parsed input string, where content key is configurable. Parsed semantic tags can be either in form of: {tag_name :: atom(), tag_content :: String.t} {tag_name :: atom(), tag :: [semantic_tag]} There are 2 special keys: content that contains parsed markdown content attributes that contains XML tag attributes","ref":"SemanticMarkdown.Type.html#t:result/0","title":"SemanticMarkdown.Type.result/0","type":"type"},{"doc":"","ref":"SemanticMarkdown.Type.html#t:semantic_inner_ast/0","title":"SemanticMarkdown.Type.semantic_inner_ast/0","type":"type"},{"doc":"","ref":"readme.html","title":"SemanticMarkdown","type":"extras"},{"doc":"SemanticMarkdown is a library that allows marking parts of the Markdown document with XML tags. Those are extracted and provided in Keyword-list form along with the non marked format. E.g.: &lt;author&gt;Alexander &quot;exlee&quot; Kaminski&lt;/author&gt; &lt;date&gt;2022-02-02&lt;/date&gt; &lt;language&gt;en_US&lt;/language&gt; # Hello World! Every document has to start somewhere?! &lt;hint&gt;It's possible to extend from World to Universe at some point&lt;/hint&gt; &lt;mobile_content&gt; As _content_ on this *page* is very intensive you will not be able to see the images! &lt;/mobile_content&gt; &lt;update&gt;2022-02-03 : Added hint&lt;/update&gt; &lt;update&gt;2022-02-04 : Set tags&lt;/update&gt; ... is transformed into friendly keyword list: [ author : ... , date : ... , language : ... , content : ... , mobile_content : ... , update : ... , update : ... ] Such list could be then used for conditional rendering or all kinds of rendering transformation using marked parts/attributes. Solution space: Have a local markdown-based CMS system Conditional content loading depending on various conditions, like locale or browser configuration (without DB) Data points embedding for interactive components Assymetrical documents (e.g. flashcards)","ref":"readme.html#description","title":"SemanticMarkdown - Description","type":"extras"},{"doc":"SemanticMarkdown can be installed by adding semantic_markdown to your list of dependencies in mix.exs : def deps do [ { :semantic_markdown , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be found at https://hexdocs.pm/semantic_markdown .","ref":"readme.html#installation","title":"SemanticMarkdown - Installation","type":"extras"},{"doc":"Markdown is a great format for short and longer forms. However it's somewhat limited when it comes to creating structured content. The usual solutions is to use either CMS system or directly database in order to feed content. Database modelling takes time and might be an overkill for small solutions. Also - Markdown is VERY good for writing content, so if the solution is small, text-driven one can use Markdown instead of trying to hammer-in back office system so that the content can be provided. Database Same semantic information can be obtained by using database. For small solutions modelling database or even setting it up can be overkill over having flat local files. Semantic marking allows for example loading markdown into local database (like SQLite3) for faster reads and incrementally extending model as needed. Footnotes At the time of writing this library Earmark hard codes see footnotes and return to article when parsing them. SemanticMarkdown provides options to replace those during parse allowing to use non-English titles (e.g. with gettext ), which was another motivation and the actual TL;DR; I wanted to have simple CMS system for a content generation, and couldn't find one, so made my own ;)","ref":"readme.html#rationale","title":"SemanticMarkdown - Rationale","type":"extras"},{"doc":"Front-matter Some Markdown parsing solutions are using &quot;header&quot; parts in order to provide data with semantic value, e.g.: date : 2022 - 02 - 02 language : en_US author : Anonymous Writer -- -- - # Title of the document ( ... ) Where front-matter can be any format (XML, TOML, YAML etc.). Such approach works well when provided data can be embedded in such data file. It doesn't allow marking parts of document and it's usually developer's responsibility to make sure that document is split in proper manner. XML Parsing XML parsing (with library such as SweetXml ) would probably be preferable. &lt; xml &gt; &lt; title &gt; ... &lt; / title &gt; &lt; content &gt; ... &lt; / content &gt; &lt; sources &gt; ... &lt; / sources &gt; &lt; / xml &gt; Since not only that would provide semantic tagging and formatting but also allow for hardening data with name spaces. However, if one decides to use it, they're on their own to implement Markdown parsing for specific nodes. Markdown classes Instead of toying with semantic tagging one could use IAL extensions (see Earmark's ) and then use other methods of hiding content (like CSS/JS). Document splitting It it's also possible to split the .md files into multiple ones using schema like, but if there are a lot of information with semantic meaning such split would be very cumbersome to uphold.","ref":"readme.html#alternative-solutions","title":"SemanticMarkdown - Alternative solutions","type":"extras"},{"doc":"[ ] it should be possible to have inner transforms on tag-by-tag or even node-by-node basis [ ] footnotes need to be in the same semantic node making them somewhat useless [ ] since parsing is done using Earmark it shares some caveats (like HTML Limitation ) [ ] no performance tests were done, but most likely it's not very fast so the input files should be pre-processed and cached [ ] it'd be nice to have tag transformers provided in form of (text) -&gt; any so that output can be &quot;smarter&quot; [ ] nested semantic tags are not supported (this probably would require switching parser entirely) Next More tests, especially with more complex documents Configurable transformers for tags Per-tag inner-parsing","ref":"readme.html#missing-features-known-issues","title":"SemanticMarkdown - Missing features / known issues","type":"extras"}]